;################################################################################
;#										#
;# libmio - multi i/o for ATMega644						#
;# viedo mode 4 engine								#
;# copyright (c) 2005-2009 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
;-------------------------------------------------------------------------------
; -output character line 5 clocks per pixel
; -128 characters are in RAM table 6x10px each
;-------------------------------------------------------------------------------
libmio_tvu:	lds	XL,libmio_rampos_l	;2 BS low
		lds	XH,libmio_rampos_h	;1 BS high
		movw	YL,XL			;2 copy values
		ldi	ZL,LOW(690)		;1 offset color table
		ldi	ZH,HIGH(690)		;1
		add	YL,ZL			;1
		adc	YH,ZH			;1

libmio_tvu_0:	ldi	ZH,0x07			;start chartable
		lds	ZL,libmio_cline		;2 character line
		inc	ZL			;1
		bst	ZL,0			;1 get LSB
		lsr	ZL			;1 /2
		add	ZH,ZL			;1

		push	tempreg4
		push	tempreg5
		ldi	ZL,30			;1 number of chars
		mov	tempreg5,ZL		;1 set loop counter
		ld	tempreg3,Y+		;2 get color
		ld	ZL,X+			;2 get char
		bld	ZL,7			;1 store LSB
		ld	tempreg2,Z		;2 get pixline
		mov	tempreg4,tempreg3	;1
		swap	tempreg4		;1
		eor	tempreg4,tempreg3	;1
		sbrc	tempreg2,7		;1
		eor	tempreg3,tempreg4	;1

libmio_tvu_1:	out	PORTC,tempreg3		;1 output P0
		ld	ZL,X+			;2 get char
		bld	ZL,7			;1 store LSB
		sbrc	tempreg2,6		;1 skip if no change

		out	PINC,tempreg4		;1 output P1
		ld	r0,Z			;2 get pixline
		nop				;1 filling
		sbrc	tempreg2,5		;1 skip if no change

		out	PINC,tempreg4		;1 output P2
		ld	tempreg3,Y+		;2 get color
		mov	r1,tempreg3		;1 copy color
		sbrc	tempreg2,4		;1 skip if no change

		out	PINC,tempreg4		;1 output P3		
;		nop				;1 filling
		swap	r1			;1 swap fg/hg
		eor	r1,tempreg3		;1 calc diffenece
		sbrc	tempreg2,3		;1 skip if no change

		
		out	PINC,tempreg4		;1 output P4		
		sbrc	r0,7			;1 check next P0
		eor	tempreg3,r1		;1 change color		
		dec	tempreg5		;1 loop counter	
		sbrc	tempreg2,2		;1 skip if no change
		
		
		out	PINC,tempreg4		;1 output P5		
		mov	tempreg2,r0		;1 prepare next pixline
		mov	tempreg4,r1		;1 prepare next colordiff
		brne	libmio_tvu_1		;2 do loop
		
		lds	tempreg3,libmio_border	;2 get border
		out	PORTC,tempreg3		;set
		pop	tempreg5
		pop	tempreg4

		ld	ZL,-X			;2 correct X-register
		lds	ZH,libmio_cline		;2 character line
		inc	ZH
		cpi	ZH,10			;1 check
		brne	libmio_tvu_2		;2 jump if not next line
		clr	ZH			;1 character line = 0
		sts	libmio_rampos_l,XL	;2 new memory position
		sts	libmio_rampos_h,XH	;2 new memory position
libmio_tvu_2:	sts	libmio_cline,ZH		;2 new character line
		jmp	libmio_is_15

